"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_usestateref_1 = __importDefault(require("react-usestateref"));
const styles_1 = require("./styles");
const styled_components_1 = require("styled-components");
const Text_1 = require("../Text");
const stopPropagation = (event) => {
    event?.stopImmediatePropagation?.();
    event?.stopPropagation?.();
    event?.nativeEvent?.stopPropagation?.();
    event?.nativeEvent?.stopImmediatePropagation?.();
};
const checkAndstopPropagation = (stop, event) => {
    if (stop)
        stopPropagation(event);
};
const Input = (props) => {
    // const [changed, setChanged] = useState(props?.onChange);
    const [type, setType] = (0, react_usestateref_1.default)(props?.type?.toLowerCase?.() || 'text');
    const inputRef = (0, react_1.useRef)(null);
    const valueState = props?.setValue
        ? [props?.value, props?.setValue, undefined]
        : (0, react_usestateref_1.default)(props.defaultValue || props.value);
    const errorState = props?.setError
        ? undefined
        : (0, react_usestateref_1.default)(props.defaultError || props.error);
    // useEffect(() => {
    //   setChanged(props?.onChange);
    // } , [props?.onChange]);
    (0, react_1.useEffect)(() => {
        setType(props?.type?.toLowerCase?.() || 'text');
    }, [props?.type]);
    (0, react_1.useEffect)(() => {
    }, [type]);
    const basicValidate = (event, value, valueState, error, setError, eventF) => {
        // console.log('basicValidate', value, valueState);
        checkAndstopPropagation(props?.stopPropagation, event);
        if (props?.validate)
            props.validate(value, valueState, error, setError, event, eventF);
        else {
            if (type === 'checkbox' || type === 'radio')
                valueState?.[1]?.(!!!valueState?.[0]);
            else
                valueState?.[1]?.(value);
            setError?.(error);
        }
        return eventF?.(event, value, valueState, error, setError);
    };
    (0, react_1.useEffect)(() => { }, [props?.error]);
    // useEffect(() => {
    // }, [props?.value]);
    (0, react_1.useEffect)(() => { }, [props, Object.values(props)]);
    const getProps = () => {
        const newProps = JSON.parse(JSON.stringify(props));
        delete newProps.error;
        delete newProps.setError;
        delete newProps.setValue;
        delete newProps.children;
        delete newProps.label;
        delete newProps.labelStyle;
        delete newProps.labelParentStyle;
        delete newProps.errorStyle;
        newProps.validate = props.validate;
        newProps.defaultValue = props?.value ? undefined : props?.defaultValue;
        if (type === 'checkbox' || type === 'radio')
            newProps.checked = valueState?.[0];
        newProps.value = valueState?.[0];
        newProps.onChange = (event) => {
            // console.log('onChange', event.target.value);
            return basicValidate(event, event.target.value, valueState, props?.error || errorState?.[0], props?.setError || errorState?.[1], props?.onChange // changed
            );
        };
        newProps.onClick = (event) => {
            checkAndstopPropagation(props?.stopPropagation, event);
            return props?.onClick?.(event, event.target.value, valueState, props?.error || errorState?.[0], props?.setError || errorState?.[1]);
        };
        newProps.onInput = (event) => {
            checkAndstopPropagation(props?.stopPropagation, event);
            return props?.onInput?.(event, event.target.value, valueState, props?.error || errorState?.[0], props?.setError || errorState?.[1]);
        };
        newProps.onSubmit = (event) => {
            checkAndstopPropagation(props?.stopPropagation, event);
            return props?.onSubmit?.(event, event.target.value, valueState, props?.error || errorState?.[0], props?.setError || errorState?.[1]);
        };
        newProps.onKeyUp = (event) => {
            // console.log('onKeyUp', event.target.value);
            checkAndstopPropagation(props?.stopPropagation, event);
            return props?.onKeyUp?.(event, event.target.value, valueState, props?.error || errorState?.[0], props?.setError || errorState?.[1]);
        };
        newProps.onKeyDown = (event) => {
            checkAndstopPropagation(props?.stopPropagation, event);
            return props?.onKeyDown?.(event, event.target.value, valueState, props?.error || errorState?.[0], props?.setError || errorState?.[1]);
        };
        if (newProps.value != undefined && newProps.checked != undefined)
            delete newProps.defaultValue;
        return newProps;
    };
    const input = type === 'file' ? (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(styles_1.Input, { ...{ ...getProps(), value: '' }, style: { display: 'none' }, ref: inputRef }),
        react_1.default.createElement(styles_1.Input, { ...{ ...getProps(), type: 'button' }, onClick: (event) => {
                // console.log('CLICK');
                // console.log('click', inputRef?.current);
                checkAndstopPropagation(props?.stopPropagation, event);
                inputRef?.current?.click();
            } }))) : (react_1.default.createElement(styles_1.Input, { checked: valueState?.[0], ...getProps(), ref: inputRef }));
    const fullInput = props.label ? (react_1.default.createElement("label", { style: props.labelParentStyle },
        react_1.default.createElement("span", { style: props.labelStyle }, props.label),
        input)) : (input);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        fullInput,
        props?.error && props?.error !== '' && props?.error !== ' ' ? (react_1.default.createElement(Text_1.Error, { style: props?.errorStyle }, props?.error)) : null));
};
exports.default = (0, styled_components_1.withTheme)(Input);
//# sourceMappingURL=index.js.map