"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Rowling = exports.Hanging = void 0;
const styled_components_1 = __importDefault(require("styled-components"));
const config_1 = require("../../../utils/config");
exports.Hanging = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  @keyframes hanging {
    0% {
      transform: rotate(-30deg);
    }
    50% {
      transform: rotate(30deg);
    }
    100% {
      transform: rotate(-30deg);
    }
  }
  width: fit-content;
  transform-origin: top;
  animation: hanging ${(props) => props?.theme?.animation?.hanging?.duration || 2}s ease infinite;
`;
exports.Rowling = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  @keyframes ${(props) => props.anti ? 'anti-' : ''}rowling {
    0% {
      transform: rotate(${(props) => props.anti ? '360deg' : '0deg'});
    }
    25% {
      transform: rotate(${(props) => props.anti ? '270deg' : '90deg'});
    }
    50% {
      transform: rotate(${(props) => props.anti ? '180deg' : '180deg'});
    }
    75% {
      transform: rotate${(props) => props.anti ? '90deg' : '270deg'});
    }
    100% {
      transform: rotate(${(props) => props.anti ? '0deg' : '360deg'});
    }
  }
  width: fit-content;
  transform-origin: center;
  animation: ${(props) => props.anti ? 'anti-' : ''}rowling ${(props) => props?.theme?.animation?.rowling?.duration || 2}s linear infinite;
`;
//# sourceMappingURL=styles.js.map